﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;

namespace XDG_ProgrammaticFieldLayouts
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            var peopleFieldLayout = CreatePeople();
            var activityFieldLayout = CreateActivities();
            XamDataGrid1.FieldLayouts.Add(peopleFieldLayout);
            XamDataGrid1.FieldLayouts.Add(activityFieldLayout);

            var ds = CreateData();
            XamDataGrid1.DataSource = ds.Tables[0].DefaultView;
        }

        private FieldLayout CreateActivities()
        {
            var fl = new FieldLayout();

            fl.Fields.Add(new Field { Name = "PersonID" });
            fl.Fields.Add(new Field { Name = "Name" });
            fl.Fields.Add(new Field { Name = "ActivityRelation" });

            return fl;
        }

        private FieldLayout CreatePeople()
        {
            var fl = new FieldLayout();

            fl.Fields.Add(new Field { Name = "ActivityID" });
            fl.Fields.Add(new Field { Name = "PersonID" });
            fl.Fields.Add(new Field { Name = "Activity" });

            return fl;
        }

        private DataSet CreateData()
        {
            var people = new DataTable("People");
            people.Columns.Add("PersonID");
            people.Columns.Add("Name");
            people.Rows.Add().ItemArray = new object[] { 1, "John" };
            people.Rows.Add().ItemArray = new object[] { 2, "Mary" };

            var activities = new DataTable("Activities");
            activities.Columns.Add("ActivityID");
            activities.Columns.Add("PersonID");
            activities.Columns.Add("Activity");
            activities.Rows.Add().ItemArray = new object[] { 1, 1, "Swimming" };
            activities.Rows.Add().ItemArray = new object[] { 2, 1, "Hiking" };
            activities.Rows.Add().ItemArray = new object[] { 3, 2, "Biking" };
            activities.Rows.Add().ItemArray = new object[] { 4, 2, "Running" };

            DataSet ds = new DataSet();
            ds.Tables.Add(people);
            ds.Tables.Add(activities);

            var relation = new DataRelation("ActivityRelation", people.Columns["PersonID"], activities.Columns["PersonID"]);
            ds.Relations.Add(relation);

            return ds;
        }
    }
}
